VTK: vtkDebugLeaks Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Friends | List of all members
vtkDebugLeaks Class Reference

identify memory leaks at program termination vtkDebugLeaks is used to report memory leaks at the exit of the program. More...

`#include <vtkDebugLeaks.h>`

Inheritance diagram for vtkDebugLeaks:
[legend]
Collaboration diagram for vtkDebugLeaks:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDebugLeaks * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkDebugLeaks * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDebugLeaks * | SafeDownCast (vtkObjectBase *o)
static void | ConstructClass (vtkObjectBase *object)
| Call this when creating a class. More...
static void | ConstructClass (const char *className)
| Call this when creating a vtkCommand or subclasses. More...
static void | DestructClass (vtkObjectBase *object)
| Call this when deleting a class. More...
static void | DestructClass (const char *className)
| Call this when deleting vtkCommand or a subclass. More...
static int | PrintCurrentLeaks ()
| Print all the values in the table. More...
static void | SetDebugLeaksObserver (vtkDebugLeaksObserver *observer)
static vtkDebugLeaksObserver * | GetDebugLeaksObserver ()
static int | GetExitError ()
| Get/Set flag for exiting with an error when leaks are present. More...
static void | SetExitError (int)
| Get/Set flag for exiting with an error when leaks are present. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDebugLeaks ()=default
| ~vtkDebugLeaks () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static int | DisplayMessageBox (const char *)
static void | ClassInitialize ()
static void | ClassFinalize ()
static void | ConstructingObject (vtkObjectBase *object)
static void | DestructingObject (vtkObjectBase *object)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Friends
class | vtkDebugLeaksManager
class | vtkObjectBase

## Additional Inherited Members
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

identify memory leaks at program termination vtkDebugLeaks is used to report memory leaks at the exit of the program.

It uses vtkObjectBase::InitializeObjectBase() (called via vtkObjectFactory macros) to intercept the construction of all VTK objects. It uses the UnRegisterInternal method of vtkObjectBase to intercept the destruction of all objects.

If not using the vtkObjectFactory macros to implement New(), be sure to call vtkObjectBase::InitializeObjectBase() explicitly on the constructed instance. The rule of thumb is that wherever "new [some vtkObjectBase subclass]" is called, vtkObjectBase::InitializeObjectBase() must be called as well.

There are exceptions to this:

- vtkCommand subclasses traditionally do not fully participate in vtkDebugLeaks registration, likely because they typically do not use vtkTypeMacro to configure GetClassName. InitializeObjectBase should not be called on vtkCommand subclasses, and all such classes will be automatically registered with vtkDebugLeaks as "vtkCommand or subclass".
- vtkInformationKey subclasses are not reference counted. They are allocated statically and registered automatically with a singleton "manager" instance. The manager ensures that all keys are cleaned up before exiting, and registration/deregistration with vtkDebugLeaks is bypassed.

A table of object name to number of instances is kept. At the exit of the program if there are still VTK objects around it will print them out. To enable this class add the flag -DVTK_DEBUG_LEAKS to the compile line, and rebuild vtkObject and vtkObjectFactory.

Tests:
  vtkDebugLeaks (Tests)

Definition at line 56 of file vtkDebugLeaks.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkDebugLeaks::Superclass

Definition at line 60 of file vtkDebugLeaks.h.

## Constructor & Destructor Documentation

## ◆ vtkDebugLeaks()

vtkDebugLeaks::vtkDebugLeaks | ( |  | ) |
| protecteddefault

## ◆ ~vtkDebugLeaks()

vtkDebugLeaks::~vtkDebugLeaks | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkDebugLeaks* vtkDebugLeaks::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkDebugLeaks::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDebugLeaks::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkDebugLeaks* vtkDebugLeaks::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDebugLeaks::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkDebugLeaks* vtkDebugLeaks::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDebugLeaks::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ ConstructClass() [1/2]

static void vtkDebugLeaks::ConstructClass | ( | vtkObjectBase * | object | ) |
| static

Call this when creating a class.

## ◆ ConstructClass() [2/2]

static void vtkDebugLeaks::ConstructClass | ( | const char * | className | ) |
| static

Call this when creating a vtkCommand or subclasses.

## ◆ DestructClass() [1/2]

static void vtkDebugLeaks::DestructClass | ( | vtkObjectBase * | object | ) |
| static

Call this when deleting a class.

## ◆ DestructClass() [2/2]

static void vtkDebugLeaks::DestructClass | ( | const char * | className | ) |
| static

Call this when deleting vtkCommand or a subclass.

## ◆ PrintCurrentLeaks()

static int vtkDebugLeaks::PrintCurrentLeaks | ( |  | ) |
| static

Print all the values in the table.

Returns non-zero if there were leaks.

## ◆ GetExitError()

static int vtkDebugLeaks::GetExitError | ( |  | ) |
| static

Get/Set flag for exiting with an error when leaks are present.

Default is on when VTK_DEBUG_LEAKS is on and off otherwise.

## ◆ SetExitError()

static void vtkDebugLeaks::SetExitError | ( | int |  | ) |
| static

Get/Set flag for exiting with an error when leaks are present.

Default is on when VTK_DEBUG_LEAKS is on and off otherwise.

## ◆ SetDebugLeaksObserver()

static void vtkDebugLeaks::SetDebugLeaksObserver | ( | vtkDebugLeaksObserver * | observer | ) |
| static

## ◆ GetDebugLeaksObserver()

static vtkDebugLeaksObserver* vtkDebugLeaks::GetDebugLeaksObserver | ( |  | ) |
| static

## ◆ DisplayMessageBox()

static int vtkDebugLeaks::DisplayMessageBox | ( | const char * |  | ) |
| staticprotected

## ◆ ClassInitialize()

static void vtkDebugLeaks::ClassInitialize | ( |  | ) |
| staticprotected

## ◆ ClassFinalize()

static void vtkDebugLeaks::ClassFinalize | ( |  | ) |
| staticprotected

## ◆ ConstructingObject()

static void vtkDebugLeaks::ConstructingObject | ( | vtkObjectBase * | object | ) |
| staticprotected

## ◆ DestructingObject()

static void vtkDebugLeaks::DestructingObject | ( | vtkObjectBase * | object | ) |
| staticprotected

## Friends And Related Function Documentation

## ◆ vtkDebugLeaksManager

friend class vtkDebugLeaksManager
| friend

Definition at line 113 of file vtkDebugLeaks.h.

## ◆ vtkObjectBase

friend class vtkObjectBase
| friend

Definition at line 114 of file vtkDebugLeaks.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkDebugLeaks.h